<?php if (!defined('PmWiki')) exit();
#
# Markdown  -  A text-to-HTML conversion tool for web writers
#
# Copyright (c) 2004-2005 John Gruber  
# <http://daringfireball.net/projects/markdown/>
#
# Copyright (c) 2004-2005 Michel Fortin - PHP Port  
# <http://www.michelf.com/projects/php-markdown/>
#
# PmWiki Conversion Copyrigh (c) 2006 Benjamin C. Wilson
# <http://www.dausha.net/Markdown/Recipe
#


#### inline markups ####
## ''emphasis''
#Markup("em",'inline',"/''(.*?)''/",'<em>$1</em>');
Markup("mkem",'inline',
  '/((?<!\\*)\\*|(?<!_)_)(?=\S)(?! \1)(.+?)(?<=\S)\1/sx','<em>$2</em>');

## '''strong'''
#Markup("strong","<em","/'''(.*?)'''/",'<strong>$1</strong>');
Markup("mkstrong", "<mkem",
      '/((?<!\\*\\*)\\*\\*|(?<!__)__)(?=\S)(?!\1)            # Start Mark
        ((?:[^*_]+?|([*_])(?=\S).+?(?<=\S)\3|(?!\1).)+?) # Content
        (?<=\S)\1                                        # End mark
       /sx', '<strong>\2</strong>');

## '''''strong emphasis'''''
#Markup("strongem","<strong","/'''''(.*?)'''''/",'<strong><em>$1</em></strong>');
Markup("mkstrongem", "<mkstrong",
      '/((?<!\\*\\*\\*)\\*\\*\\*|(?<!___)___)(?=\S)(?!\1)# Start Mark
        ((?:[^*_]+?|([*_])(?=\S).+?(?<=\S)\3|(?!\1).)+?) # Content
        (?<=\S)\1                                        # End mark
       /sx', '<strong><em>\2</em></strong>');


## @@code@@
Markup('code','inline','/@@(.*?)@@/','<code>$1</code>');
Markup("mkcode",'inline',
  '/((?<!`)`|(?<!_)_)(?=\S)(?! \1)(.+?)(?<=\S)\1/sx','<code>$2</code>');

## '+big+', '-small-'
Markup("'big","<strongem","/'\\+(.*?)\\+'/",'<big>$1</big>');
Markup("small","<strongem","/'\\-(.*?)\\-'/",'<small>$1</small>');

## '^superscript^', '_subscript_'
Markup("super","<strongem","/'\\^(.*?)\\^'/",'<sup>$1</sup>');
Markup("sub","<strongem","/'_(.*?)_'/",'<sub>$1</sub>');

## [+big+], [-small-]
Markup('[+','inline','/\\[(([-+])+)(.*?)\\1\\]/e',
  "'<span style=\'font-size:'.(round(pow(6/5,$2strlen('$1'))*100,0)).'%\'>'.
    PSS('$3</span>')");

## {+ins+}, {-del-}
Markup('ins','inline','/\\{\\+(.*?)\\+\\}/','<ins>$1</ins>');
Markup('del','inline','/\\{-(.*?)-\\}/','<del>$1</del>');

## [[<<]] (break)
Markup('brclear','inline','/\\[\\[&lt;&lt;\\]\\]/',"<br clear='all' />");

